#include "basic_vert.glsl"

uniform vec3 modelOffset;


void main() {

    texCoord = vaUV0;
    foliageColor = vaColor.rgb;
    lightMapCoords = vaUV2 * (1.0 / 256.0) + (1.0 / 32.0);

    vec3 worldSpaceVertexPosition = cameraPosition + (gbufferModelViewInverse * modelViewMatrix * vec4(vaPosition + modelOffset,1)).xyz;

    float distanceFromCamera = distance(worldSpaceVertexPosition, cameraPosition);

    gl_Position =  projectionMatrix * modelViewMatrix * vec4(vaPosition + modelOffset -  distanceFromCamera * 0.02,1);
}